/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package agregacionbomba;

import javax.swing.JOptionPane;

/**
 *
 * @author ionix
 */
public class jifGasolina extends javax.swing.JInternalFrame {

    /**
     * Creates new form jifGasolina
     */
    public jifGasolina() {
        initComponents();
        this.deshabilitar();
        this.habilitar();
    }
    
    public void deshabilitar(){
        this.txtCantidad.setEnabled(false);
        this.txtContador.setEnabled(false);
        this.txtNumBomba.setEnabled(false);
        this.txtPrecio.setEnabled(false);
        this.txtTotalVenta.setEnabled(false);
        this.cmbTipo.setEnabled(false);
        this.jslCapacidad.setEnabled(false);
        this.btnHacerVenta.setEnabled(false);
        this.btnInicia.setEnabled(false);
    }
    
    public void habilitar(){
        this.txtNumBomba.setEnabled(!false);
        this.cmbTipo.setEnabled(!false);
        this.jslCapacidad.setEnabled(!false);
        this.btnInicia.setEnabled(!false);
        this.txtPrecio.setEnabled(!false);
    }
    
    public boolean validar(){
        boolean exito=false;
          if(this.txtNumBomba.getText().equals("")) exito=true;
          if(this.jslCapacidad.getValue()==0) exito=true;
        return exito;
    }
    
    public void limpiar(){
        this.txtNumBomba.setText("");
        this.txtContador.setText("");
        this.txtTotalVenta.setText("");
        this.txtCantidad.setText("");
        this.txtPrecio.setText("");
        this.lblMensaje.setText("Mensaje: ");
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        cmbTipo = new javax.swing.JComboBox<>();
        jLabel4 = new javax.swing.JLabel();
        txtNumBomba = new javax.swing.JTextField();
        txtContador = new javax.swing.JTextField();
        txtPrecio = new javax.swing.JTextField();
        jslCapacidad = new javax.swing.JSlider();
        btnInicia = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        lblMensaje = new javax.swing.JLabel();
        txtCantidad = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        btnHacerVenta = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        txtTotalVenta = new javax.swing.JTextField();
        btnCerrar = new javax.swing.JButton();
        btnLimpiar = new javax.swing.JButton();
        btnCancelar = new javax.swing.JButton();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Bomba de Gasolina");
        getContentPane().setLayout(null);

        jPanel1.setBackground(new java.awt.Color(204, 0, 0));
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Pemex", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 24), new java.awt.Color(255, 255, 255))); // NOI18N
        jPanel1.setLayout(null);

        jLabel1.setBackground(new java.awt.Color(255, 255, 255));
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("Precio de Venta");
        jPanel1.add(jLabel1);
        jLabel1.setBounds(430, 90, 140, 40);

        jLabel2.setBackground(new java.awt.Color(255, 255, 255));
        jLabel2.setForeground(new java.awt.Color(255, 255, 255));
        jLabel2.setText("Num. Bomba");
        jPanel1.add(jLabel2);
        jLabel2.setBounds(30, 40, 110, 40);

        jLabel3.setBackground(new java.awt.Color(255, 255, 255));
        jLabel3.setForeground(new java.awt.Color(255, 255, 255));
        jLabel3.setText("Tipos de Gasolinas");
        jPanel1.add(jLabel3);
        jLabel3.setBounds(200, 40, 140, 40);

        cmbTipo.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Regular", "Premium" }));
        cmbTipo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbTipoActionPerformed(evt);
            }
        });
        jPanel1.add(cmbTipo);
        cmbTipo.setBounds(200, 80, 140, 40);

        jLabel4.setBackground(new java.awt.Color(255, 255, 255));
        jLabel4.setForeground(new java.awt.Color(255, 255, 255));
        jLabel4.setText("Contador de Litros");
        jPanel1.add(jLabel4);
        jLabel4.setBounds(430, 40, 140, 40);

        txtNumBomba.setText("0");
        txtNumBomba.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtNumBombaActionPerformed(evt);
            }
        });
        jPanel1.add(txtNumBomba);
        txtNumBomba.setBounds(20, 80, 130, 40);

        txtContador.setText("0");
        txtContador.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtContadorActionPerformed(evt);
            }
        });
        jPanel1.add(txtContador);
        txtContador.setBounds(580, 40, 130, 40);

        txtPrecio.setText("0");
        txtPrecio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtPrecioActionPerformed(evt);
            }
        });
        jPanel1.add(txtPrecio);
        txtPrecio.setBounds(580, 90, 130, 40);

        jslCapacidad.setMajorTickSpacing(10);
        jslCapacidad.setPaintLabels(true);
        jslCapacidad.setPaintTicks(true);
        jPanel1.add(jslCapacidad);
        jslCapacidad.setBounds(20, 160, 840, 61);

        btnInicia.setText("Iniciar bomba");
        btnInicia.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnIniciaActionPerformed(evt);
            }
        });
        jPanel1.add(btnInicia);
        btnInicia.setBounds(730, 50, 130, 70);

        getContentPane().add(jPanel1);
        jPanel1.setBounds(20, 20, 900, 250);

        jPanel2.setBackground(new java.awt.Color(153, 153, 153));
        jPanel2.setLayout(null);

        lblMensaje.setText("Mensaje");
        jPanel2.add(lblMensaje);
        lblMensaje.setBounds(180, 100, 110, 40);

        txtCantidad.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        txtCantidad.setText("0");
        jPanel2.add(txtCantidad);
        txtCantidad.setBounds(150, 40, 140, 40);

        jLabel7.setText("Cantidad");
        jPanel2.add(jLabel7);
        jLabel7.setBounds(50, 40, 110, 40);

        btnHacerVenta.setText("Hacer la Venta");
        btnHacerVenta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnHacerVentaActionPerformed(evt);
            }
        });
        jPanel2.add(btnHacerVenta);
        btnHacerVenta.setBounds(340, 40, 160, 40);

        getContentPane().add(jPanel2);
        jPanel2.setBounds(130, 370, 670, 160);

        jLabel5.setFont(new java.awt.Font("Tahoma", 0, 36)); // NOI18N
        jLabel5.setText("Venta de Gasolina");
        getContentPane().add(jLabel5);
        jLabel5.setBounds(330, 300, 290, 60);

        jLabel8.setText("Total Venta   $");
        getContentPane().add(jLabel8);
        jLabel8.setBounds(560, 550, 120, 50);

        txtTotalVenta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtTotalVentaActionPerformed(evt);
            }
        });
        getContentPane().add(txtTotalVenta);
        txtTotalVenta.setBounds(690, 560, 100, 30);

        btnCerrar.setText("Cerrar");
        btnCerrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCerrarActionPerformed(evt);
            }
        });
        getContentPane().add(btnCerrar);
        btnCerrar.setBounds(390, 580, 140, 40);

        btnLimpiar.setText("Limpiar");
        btnLimpiar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnLimpiarActionPerformed(evt);
            }
        });
        getContentPane().add(btnLimpiar);
        btnLimpiar.setBounds(40, 580, 140, 40);

        btnCancelar.setText("Cancelar");
        btnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelarActionPerformed(evt);
            }
        });
        getContentPane().add(btnCancelar);
        btnCancelar.setBounds(220, 580, 140, 40);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void txtNumBombaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtNumBombaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtNumBombaActionPerformed

    private void txtContadorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtContadorActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtContadorActionPerformed

    private void txtPrecioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtPrecioActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtPrecioActionPerformed

    private void cmbTipoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbTipoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_cmbTipoActionPerformed

    private void txtTotalVentaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtTotalVentaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtTotalVentaActionPerformed

    private void btnHacerVentaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnHacerVentaActionPerformed
        // TODO add your handling code here:
        if(bomba.realizarVenta(Float.parseFloat(this.txtCantidad.getText()))==true){
            float can = bomba.getContador() + Float.parseFloat(this.txtCantidad.getText());
            bomba.setContador(can);
            this.txtContador.setText(String.valueOf(bomba.getContador()));
            this.txtTotalVenta.setText(String.valueOf(bomba.calcularTotalVenta()));
            this.jslCapacidad.setValue(Math.round(bomba.obtenerInventario()));
            this.lblMensaje.setText("Mensaje: Venta exitosa "+this.txtCantidad.getText()+" litros acumulados a $"+Float.parseFloat(this.txtCantidad.getText())*bomba.getGasolina().getPrecio());
        }
        else{
            this.lblMensaje.setText("Mensaje: Inventario insuficiente para la Venta");
        }
    }//GEN-LAST:event_btnHacerVentaActionPerformed

    private void btnCerrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCerrarActionPerformed
        // TODO add your handling code here:
        int opcion = 0;
        opcion = JOptionPane.showConfirmDialog(this, "Deseas salir?", "Bomba de Gasolina", JOptionPane.YES_NO_OPTION);
        if (opcion == JOptionPane.YES_OPTION){
            this.dispose();
        }
    }//GEN-LAST:event_btnCerrarActionPerformed

    private void btnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelarActionPerformed
        // TODO add your handling code here:
        this.limpiar();
        this.deshabilitar();
        this.habilitar();
        bomba = new Bomba();
    }//GEN-LAST:event_btnCancelarActionPerformed

    private void btnLimpiarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnLimpiarActionPerformed
        // TODO add your handling code here:
        this.limpiar();
    }//GEN-LAST:event_btnLimpiarActionPerformed

    private void btnIniciaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnIniciaActionPerformed
        // TODO add your handling code here:
        if (this.validar()==false){
            bomba.setNumBomba(Integer.parseInt(this.txtNumBomba.getText()));
            bomba.setCapacidad(this.jslCapacidad.getValue());
            int tipo = this.cmbTipo.getSelectedIndex();
            switch(tipo){
                case 0: 
                    Gasolina gas = new Gasolina(1,"PEMEX",0,Float.parseFloat(this.txtPrecio.getText()));
                    bomba.setGasolina(gas); break;
                case 1:
                    Gasolina gas1 = new Gasolina(2,"PEMEX",1,Float.parseFloat(this.txtPrecio.getText()));
                    bomba.setGasolina(gas1); break;
            }
            this.deshabilitar();
            this.txtCantidad.setEnabled(!false);
            this.btnHacerVenta.setEnabled(!false);
        }
        else{
            JOptionPane.showMessageDialog(this, "Falto capturar informacion");
        }
    }//GEN-LAST:event_btnIniciaActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancelar;
    private javax.swing.JButton btnCerrar;
    private javax.swing.JButton btnHacerVenta;
    private javax.swing.JButton btnInicia;
    private javax.swing.JButton btnLimpiar;
    private javax.swing.JComboBox<String> cmbTipo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JSlider jslCapacidad;
    private javax.swing.JLabel lblMensaje;
    private javax.swing.JTextField txtCantidad;
    private javax.swing.JTextField txtContador;
    private javax.swing.JTextField txtNumBomba;
    private javax.swing.JTextField txtPrecio;
    private javax.swing.JTextField txtTotalVenta;
    // End of variables declaration//GEN-END:variables
    private Bomba bomba;
}
